<template>
  <div
    :class="{ 'MachineLane--active': active }"
    :style="computeStyle(resolution, ratioCurrentHour)"
    class="MachineLane"
    @dragenter="dragIn"
    @dragleave="dragOut"
    @dragover="dragIn"
    @drop="drop"
    ref="element"
  >
    <Link
      :to="'/machine/' + machine.id"
      title="Go to machine view"
      class="MachineLane__name"
      >{{ machine.name }}</Link
    >
    <span class="MachineLane__now" :style="{ left: offsetNow + 'px' }" />

    <ScheduledOrder
      class="MachineLane__Order"
      v-for="order of machine.orders"
      :key="order.id"
      :now="now"
      :offset-now="offsetNow"
      :order="order"
      :resolution="resolution"
    />
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, PropType, ref } from 'vue'
import ScheduledOrder from '@/views/partial/ScheduledOrder.vue'
import { Machine } from '@/types'
import { workshop } from '@/states'
import { Order as HelperOrder } from '@/helpers'
import moment from 'moment'
import { Link } from '@/components'

export default defineComponent({
  name: 'MachineLane',
  components: { ScheduledOrder, Link },

  props: {
    machine: {
      type: Object as PropType<Machine>,
      required: true,
    },

    now: {
      type: Object,
      required: true,
    },

    resolution: {
      type: Number,
      required: true,
    },

    offsetNow: {
      type: Number,
      required: true,
    },
  },

  setup(props) {
    const element = ref<HTMLDivElement>()

    return {
      active: ref(false),
      ratioCurrentHour: computed(() => moment(props.now).minutes() / 60),
      element,
    }
  },

  methods: {
    /**
     * Compute style of the lane depending on its state (active or not)
     *
     * @param {number} resolution
     * @param {number} ratioCurrentHour
     */
    computeStyle(resolution: number, ratioCurrentHour: number) {
      return {
        ...{width: resolution * 24 + 'px'},
        ...this.computeBackground(resolution, ratioCurrentHour)
      }
    },

    /**
     * Compute background of the lane depending on its state (active or not)
     *
     * @param {number} resolution
     * @param {number} ratioCurrentHour
     */
    computeBackground(resolution: number, ratioCurrentHour: number) {
      if (this.active) {
        return { background: 'var(--machineLane-active)' }
      }

      return {
        backgroundImage:
          'repeating-linear-gradient(90deg, #fafafa, #fafafa ' +
          resolution +
          'px, #ffffff ' +
          resolution +
          'px, #ffffff ' +
          resolution * 2 +
          'px)',
        backgroundPosition: -resolution * ratioCurrentHour + 'px 0',
        backgroundSize: resolution * 24 + 'px',
      }
    },

    dragIn(e: DragEvent) {
      e.preventDefault()
      this.active = true
    },

    dragOut(e: DragEvent) {
      e.preventDefault()
      this.active = false
    },

    drop(e: DragEvent) {
      this.active = false

      // get the draggable element
      if (e.dataTransfer) {
        const id = e.dataTransfer.getData('orderId')
        const offset = parseInt(e.dataTransfer.getData('offset')) || 0
        const order = workshop.orders[id]
        if (order && this.element) {
          const box = this.element.getBoundingClientRect()

          HelperOrder.schedule(
            order,

            moment(this.now)
              .add(
                (e.x - box.x - offset - this.offsetNow) / this.resolution,
                'hours'
              )
              .toDate(),
            this.machine.id
          )
        }
      }
    },
  },
})
</script>

<style lang="scss" scoped>
@use '../../style/variables' as v;

.MachineLane {
  $offset-left: 200px;

  position: relative;
  display: inline-flex;
  flex-wrap: nowrap;
  align-items: center;
  width: 100%;
  min-height: v.$machine-lineHeight;
  max-height: v.$machine-lineHeight;
  border-bottom: solid 1px #f8f8f8;
  transition: background-color linear 200ms;

  &--active {
    .MachineLane__Order {
      opacity: 40%;
      transition: opacity linear 200ms;
    }
  }

  &__name {
    position: sticky;
    left: 0;
    z-index: 20;
    display: inline-flex;
    align-items: center;
    justify-content: stretch;
    min-width: $offset-left;
    max-width: $offset-left;
    height: 100%;
    padding: v.$spacing;
    border-right: 2px solid var(--border-color);
    background-color: var(--background-color);
    font-weight: 700;
  }

  &__now {
    position: absolute;
    z-index: 10;
    height: 100%;
    border-right: 1px solid red;
  }
}
</style>
